"""
    Asana

    This is the interface for interacting with the [Asana Platform](https://developers.asana.com). Our API reference is generated from our [OpenAPI spec] (https://raw.githubusercontent.com/Asana/openapi/master/defs/asana_oas.yaml).  # noqa: E501

    The version of the OpenAPI document: 1.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from asana_preview.api_client import ApiClient, Endpoint as _Endpoint
from asana_preview.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from asana_preview.model.add_supporting_relationship_request import AddSupportingRelationshipRequest
from asana_preview.model.delete_attachment200_response import DeleteAttachment200Response
from asana_preview.model.error_response import ErrorResponse
from asana_preview.model.get_goal_relationship200_response import GetGoalRelationship200Response
from asana_preview.model.get_goal_relationships200_response import GetGoalRelationships200Response
from asana_preview.model.remove_supporting_relationship_request import RemoveSupportingRelationshipRequest
from asana_preview.model.update_goal_relationship_request import UpdateGoalRelationshipRequest


class GoalRelationshipsApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.add_supporting_relationship_endpoint = _Endpoint(
            settings={
                'response_type': (GetGoalRelationship200Response,),
                'auth': [
                    'personalAccessToken'
                ],
                'endpoint_path': '/goals/{goal_gid}/addSupportingRelationship',
                'operation_id': 'add_supporting_relationship',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'goal_gid',
                    'add_supporting_relationship_request',
                    'opt_pretty',
                    'opt_fields',
                ],
                'required': [
                    'goal_gid',
                    'add_supporting_relationship_request',
                ],
                'nullable': [
                ],
                'enum': [
                    'opt_fields',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('opt_fields',): {

                        "SUPPORTING_RESOURCE": "supporting_resource",
                        "SUPPORTED_GOAL": "supported_goal",
                        "CONTRIBUTION_WEIGHT": "contribution_weight",
                        "RESOURCE_SUBTYPE": "resource_subtype"
                    },
                },
                'openapi_types': {
                    'goal_gid':
                        (str,),
                    'add_supporting_relationship_request':
                        (AddSupportingRelationshipRequest,),
                    'opt_pretty':
                        (bool,),
                    'opt_fields':
                        ([str],),
                },
                'attribute_map': {
                    'goal_gid': 'goal_gid',
                    'opt_pretty': 'opt_pretty',
                    'opt_fields': 'opt_fields',
                },
                'location_map': {
                    'goal_gid': 'path',
                    'add_supporting_relationship_request': 'body',
                    'opt_pretty': 'query',
                    'opt_fields': 'query',
                },
                'collection_format_map': {
                    'opt_fields': 'csv',
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.get_goal_relationship_endpoint = _Endpoint(
            settings={
                'response_type': (GetGoalRelationship200Response,),
                'auth': [
                    'personalAccessToken'
                ],
                'endpoint_path': '/goal_relationships/{goal_relationship_gid}',
                'operation_id': 'get_goal_relationship',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'goal_relationship_gid',
                    'opt_pretty',
                    'opt_fields',
                ],
                'required': [
                    'goal_relationship_gid',
                ],
                'nullable': [
                ],
                'enum': [
                    'opt_fields',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('opt_fields',): {

                        "SUPPORTING_RESOURCE": "supporting_resource",
                        "SUPPORTED_GOAL": "supported_goal",
                        "CONTRIBUTION_WEIGHT": "contribution_weight",
                        "RESOURCE_SUBTYPE": "resource_subtype"
                    },
                },
                'openapi_types': {
                    'goal_relationship_gid':
                        (str,),
                    'opt_pretty':
                        (bool,),
                    'opt_fields':
                        ([str],),
                },
                'attribute_map': {
                    'goal_relationship_gid': 'goal_relationship_gid',
                    'opt_pretty': 'opt_pretty',
                    'opt_fields': 'opt_fields',
                },
                'location_map': {
                    'goal_relationship_gid': 'path',
                    'opt_pretty': 'query',
                    'opt_fields': 'query',
                },
                'collection_format_map': {
                    'opt_fields': 'csv',
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_goal_relationships_endpoint = _Endpoint(
            settings={
                'response_type': (GetGoalRelationships200Response,),
                'auth': [
                    'personalAccessToken'
                ],
                'endpoint_path': '/goal_relationships',
                'operation_id': 'get_goal_relationships',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'supported_goal',
                    'opt_pretty',
                    'resource_subtype',
                    'opt_fields',
                ],
                'required': [
                    'supported_goal',
                ],
                'nullable': [
                ],
                'enum': [
                    'opt_fields',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('opt_fields',): {

                        "SUPPORTING_RESOURCE": "supporting_resource",
                        "SUPPORTED_GOAL": "supported_goal",
                        "CONTRIBUTION_WEIGHT": "contribution_weight",
                        "RESOURCE_SUBTYPE": "resource_subtype"
                    },
                },
                'openapi_types': {
                    'supported_goal':
                        (str,),
                    'opt_pretty':
                        (bool,),
                    'resource_subtype':
                        (str,),
                    'opt_fields':
                        ([str],),
                },
                'attribute_map': {
                    'supported_goal': 'supported_goal',
                    'opt_pretty': 'opt_pretty',
                    'resource_subtype': 'resource_subtype',
                    'opt_fields': 'opt_fields',
                },
                'location_map': {
                    'supported_goal': 'query',
                    'opt_pretty': 'query',
                    'resource_subtype': 'query',
                    'opt_fields': 'query',
                },
                'collection_format_map': {
                    'opt_fields': 'csv',
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.remove_supporting_relationship_endpoint = _Endpoint(
            settings={
                'response_type': (DeleteAttachment200Response,),
                'auth': [
                    'personalAccessToken'
                ],
                'endpoint_path': '/goals/{goal_gid}/removeSupportingRelationship',
                'operation_id': 'remove_supporting_relationship',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'goal_gid',
                    'remove_supporting_relationship_request',
                    'opt_pretty',
                ],
                'required': [
                    'goal_gid',
                    'remove_supporting_relationship_request',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'goal_gid':
                        (str,),
                    'remove_supporting_relationship_request':
                        (RemoveSupportingRelationshipRequest,),
                    'opt_pretty':
                        (bool,),
                },
                'attribute_map': {
                    'goal_gid': 'goal_gid',
                    'opt_pretty': 'opt_pretty',
                },
                'location_map': {
                    'goal_gid': 'path',
                    'remove_supporting_relationship_request': 'body',
                    'opt_pretty': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.update_goal_relationship_endpoint = _Endpoint(
            settings={
                'response_type': (GetGoalRelationship200Response,),
                'auth': [
                    'personalAccessToken'
                ],
                'endpoint_path': '/goal_relationships/{goal_relationship_gid}',
                'operation_id': 'update_goal_relationship',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'goal_relationship_gid',
                    'update_goal_relationship_request',
                    'opt_pretty',
                    'opt_fields',
                ],
                'required': [
                    'goal_relationship_gid',
                    'update_goal_relationship_request',
                ],
                'nullable': [
                ],
                'enum': [
                    'opt_fields',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('opt_fields',): {

                        "SUPPORTING_RESOURCE": "supporting_resource",
                        "SUPPORTED_GOAL": "supported_goal",
                        "CONTRIBUTION_WEIGHT": "contribution_weight",
                        "RESOURCE_SUBTYPE": "resource_subtype"
                    },
                },
                'openapi_types': {
                    'goal_relationship_gid':
                        (str,),
                    'update_goal_relationship_request':
                        (UpdateGoalRelationshipRequest,),
                    'opt_pretty':
                        (bool,),
                    'opt_fields':
                        ([str],),
                },
                'attribute_map': {
                    'goal_relationship_gid': 'goal_relationship_gid',
                    'opt_pretty': 'opt_pretty',
                    'opt_fields': 'opt_fields',
                },
                'location_map': {
                    'goal_relationship_gid': 'path',
                    'update_goal_relationship_request': 'body',
                    'opt_pretty': 'query',
                    'opt_fields': 'query',
                },
                'collection_format_map': {
                    'opt_fields': 'csv',
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )

    def add_supporting_relationship(
        self,
        goal_gid,
        add_supporting_relationship_request,
        **kwargs
    ):
        """Add a supporting goal relationship  # noqa: E501

        Creates a goal relationship by adding a supporting resource to a given goal.  Returns the newly created goal relationship record.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.add_supporting_relationship(goal_gid, add_supporting_relationship_request, async_req=True)
        >>> result = thread.get()

        Args:
            goal_gid (str): Globally unique identifier for the goal.
            add_supporting_relationship_request (AddSupportingRelationshipRequest): The supporting resource to be added to the goal

        Keyword Args:
            opt_pretty (bool): Provides “pretty” output. Provides the response in a “pretty” format. In the case of JSON this means doing proper line breaking and indentation to make it readable. This will take extra time and increase the response size so it is advisable only to use this during debugging.. [optional]
            opt_fields ([str]): This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include.. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            GetGoalRelationship200Response
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['goal_gid'] = \
            goal_gid
        kwargs['add_supporting_relationship_request'] = \
            add_supporting_relationship_request
        return self.add_supporting_relationship_endpoint.call_with_http_info(**kwargs)

    def get_goal_relationship(
        self,
        goal_relationship_gid,
        **kwargs
    ):
        """Get a goal relationship  # noqa: E501

        Returns the complete updated goal relationship record for a single goal relationship.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_goal_relationship(goal_relationship_gid, async_req=True)
        >>> result = thread.get()

        Args:
            goal_relationship_gid (str): Globally unique identifier for the goal relationship.

        Keyword Args:
            opt_pretty (bool): Provides “pretty” output. Provides the response in a “pretty” format. In the case of JSON this means doing proper line breaking and indentation to make it readable. This will take extra time and increase the response size so it is advisable only to use this during debugging.. [optional]
            opt_fields ([str]): This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include.. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            GetGoalRelationship200Response
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['goal_relationship_gid'] = \
            goal_relationship_gid
        return self.get_goal_relationship_endpoint.call_with_http_info(**kwargs)

    def get_goal_relationships(
        self,
        supported_goal,
        **kwargs
    ):
        """Get goal relationships  # noqa: E501

        Returns compact goal relationship records.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_goal_relationships(supported_goal, async_req=True)
        >>> result = thread.get()

        Args:
            supported_goal (str): Globally unique identifier for the supported goal in the goal relationship.

        Keyword Args:
            opt_pretty (bool): Provides “pretty” output. Provides the response in a “pretty” format. In the case of JSON this means doing proper line breaking and indentation to make it readable. This will take extra time and increase the response size so it is advisable only to use this during debugging.. [optional]
            resource_subtype (str): If provided, filter to goal relationships with a given resource_subtype.. [optional]
            opt_fields ([str]): This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include.. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            GetGoalRelationships200Response
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['supported_goal'] = \
            supported_goal
        return self.get_goal_relationships_endpoint.call_with_http_info(**kwargs)

    def remove_supporting_relationship(
        self,
        goal_gid,
        remove_supporting_relationship_request,
        **kwargs
    ):
        """Removes a supporting goal relationship  # noqa: E501

        Removes a goal relationship for a given parent goal.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.remove_supporting_relationship(goal_gid, remove_supporting_relationship_request, async_req=True)
        >>> result = thread.get()

        Args:
            goal_gid (str): Globally unique identifier for the goal.
            remove_supporting_relationship_request (RemoveSupportingRelationshipRequest): The supporting resource to be removed from the goal

        Keyword Args:
            opt_pretty (bool): Provides “pretty” output. Provides the response in a “pretty” format. In the case of JSON this means doing proper line breaking and indentation to make it readable. This will take extra time and increase the response size so it is advisable only to use this during debugging.. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            DeleteAttachment200Response
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['goal_gid'] = \
            goal_gid
        kwargs['remove_supporting_relationship_request'] = \
            remove_supporting_relationship_request
        return self.remove_supporting_relationship_endpoint.call_with_http_info(**kwargs)

    def update_goal_relationship(
        self,
        goal_relationship_gid,
        update_goal_relationship_request,
        **kwargs
    ):
        """Update a goal relationship  # noqa: E501

        An existing goal relationship can be updated by making a PUT request on the URL for that goal relationship. Only the fields provided in the `data` block will be updated; any unspecified fields will remain unchanged.  Returns the complete updated goal relationship record.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_goal_relationship(goal_relationship_gid, update_goal_relationship_request, async_req=True)
        >>> result = thread.get()

        Args:
            goal_relationship_gid (str): Globally unique identifier for the goal relationship.
            update_goal_relationship_request (UpdateGoalRelationshipRequest): The updated fields for the goal relationship.

        Keyword Args:
            opt_pretty (bool): Provides “pretty” output. Provides the response in a “pretty” format. In the case of JSON this means doing proper line breaking and indentation to make it readable. This will take extra time and increase the response size so it is advisable only to use this during debugging.. [optional]
            opt_fields ([str]): This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include.. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            GetGoalRelationship200Response
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['goal_relationship_gid'] = \
            goal_relationship_gid
        kwargs['update_goal_relationship_request'] = \
            update_goal_relationship_request
        return self.update_goal_relationship_endpoint.call_with_http_info(**kwargs)

