"""
    Asana

    This is the interface for interacting with the [Asana Platform](https://developers.asana.com). Our API reference is generated from our [OpenAPI spec] (https://raw.githubusercontent.com/Asana/openapi/master/defs/asana_oas.yaml).  # noqa: E501

    The version of the OpenAPI document: 1.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from asana_preview.api_client import ApiClient, Endpoint as _Endpoint
from asana_preview.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from asana_preview.model.error_response import ErrorResponse
from asana_preview.model.trigger_rule200_response import TriggerRule200Response
from asana_preview.model.trigger_rule_request import TriggerRuleRequest


class RulesApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.trigger_rule_endpoint = _Endpoint(
            settings={
                'response_type': (TriggerRule200Response,),
                'auth': [
                    'personalAccessToken'
                ],
                'endpoint_path': '/rule_triggers/{rule_trigger_gid}/run',
                'operation_id': 'trigger_rule',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'rule_trigger_gid',
                    'trigger_rule_request',
                    'opt_fields',
                ],
                'required': [
                    'rule_trigger_gid',
                    'trigger_rule_request',
                ],
                'nullable': [
                ],
                'enum': [
                    'opt_fields',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('opt_fields',): {

                        "MESSAGE": "message"
                    },
                },
                'openapi_types': {
                    'rule_trigger_gid':
                        (str,),
                    'trigger_rule_request':
                        (TriggerRuleRequest,),
                    'opt_fields':
                        ([str],),
                },
                'attribute_map': {
                    'rule_trigger_gid': 'rule_trigger_gid',
                    'opt_fields': 'opt_fields',
                },
                'location_map': {
                    'rule_trigger_gid': 'path',
                    'trigger_rule_request': 'body',
                    'opt_fields': 'query',
                },
                'collection_format_map': {
                    'opt_fields': 'csv',
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )

    def trigger_rule(
        self,
        rule_trigger_gid,
        trigger_rule_request,
        **kwargs
    ):
        """Trigger a rule  # noqa: E501

        Trigger a rule which uses an [\"incoming web request\"](/docs/incoming-web-requests) trigger.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.trigger_rule(rule_trigger_gid, trigger_rule_request, async_req=True)
        >>> result = thread.get()

        Args:
            rule_trigger_gid (str): The ID of the incoming web request trigger. This value is a path parameter that is automatically generated for the API endpoint.
            trigger_rule_request (TriggerRuleRequest): A dictionary of variables accessible from within the rule.

        Keyword Args:
            opt_fields ([str]): This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include.. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            TriggerRule200Response
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['rule_trigger_gid'] = \
            rule_trigger_gid
        kwargs['trigger_rule_request'] = \
            trigger_rule_request
        return self.trigger_rule_endpoint.call_with_http_info(**kwargs)

