"""
    Asana

    This is the interface for interacting with the [Asana Platform](https://developers.asana.com). Our API reference is generated from our [OpenAPI spec] (https://raw.githubusercontent.com/Asana/openapi/master/defs/asana_oas.yaml).  # noqa: E501

    The version of the OpenAPI document: 1.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from asana_preview.api_client import ApiClient, Endpoint as _Endpoint
from asana_preview.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from asana_preview.model.delete_attachment200_response import DeleteAttachment200Response
from asana_preview.model.error_response import ErrorResponse
from asana_preview.model.get_stories_for_task200_response import GetStoriesForTask200Response
from asana_preview.model.get_story200_response import GetStory200Response
from asana_preview.model.update_story_request import UpdateStoryRequest


class StoriesApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.create_story_for_task_endpoint = _Endpoint(
            settings={
                'response_type': (GetStory200Response,),
                'auth': [
                    'personalAccessToken'
                ],
                'endpoint_path': '/tasks/{task_gid}/stories',
                'operation_id': 'create_story_for_task',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'task_gid',
                    'update_story_request',
                    'opt_pretty',
                    'opt_fields',
                ],
                'required': [
                    'task_gid',
                    'update_story_request',
                ],
                'nullable': [
                ],
                'enum': [
                    'opt_fields',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('opt_fields',): {

                        "CREATED_AT": "created_at",
                        "NEW_ENUM_VALUE": "new_enum_value",
                        "CREATED_BY": "created_by",
                        "NEW_NUMBER_VALUE": "new_number_value",
                        "IS_EDITED": "is_edited",
                        "PREVIEWS": "previews",
                        "OLD_MULTI_ENUM_VALUES": "old_multi_enum_values",
                        "NEW_NAME": "new_name",
                        "NEW_PEOPLE_VALUE": "new_people_value",
                        "PROJECT": "project",
                        "FOLLOWER": "follower",
                        "NEW_RESOURCE_SUBTYPE": "new_resource_subtype",
                        "TAG": "tag",
                        "OLD_RESOURCE_SUBTYPE": "old_resource_subtype",
                        "TASK": "task",
                        "IS_EDITABLE": "is_editable",
                        "STICKER_NAME": "sticker_name",
                        "STORY": "story",
                        "NEW_SECTION": "new_section",
                        "NUM_LIKES": "num_likes",
                        "NUM_HEARTS": "num_hearts",
                        "OLD_NAME": "old_name",
                        "RESOURCE_SUBTYPE": "resource_subtype",
                        "HTML_TEXT": "html_text",
                        "DUPLICATE_OF": "duplicate_of",
                        "HEARTS": "hearts",
                        "SOURCE": "source",
                        "TARGET": "target",
                        "LIKES": "likes",
                        "LIKED": "liked",
                        "OLD_DATE_VALUE": "old_date_value",
                        "OLD_ENUM_VALUE": "old_enum_value",
                        "HEARTED": "hearted",
                        "OLD_SECTION": "old_section",
                        "NEW_DATE_VALUE": "new_date_value",
                        "TYPE": "type",
                        "NEW_APPROVAL_STATUS": "new_approval_status",
                        "TEXT": "text",
                        "OLD_PEOPLE_VALUE": "old_people_value",
                        "ASSIGNEE": "assignee",
                        "NEW_DATES": "new_dates",
                        "NEW_TEXT_VALUE": "new_text_value",
                        "DUPLICATED_FROM": "duplicated_from",
                        "CUSTOM_FIELD": "custom_field",
                        "DEPENDENCY": "dependency",
                        "OLD_TEXT_VALUE": "old_text_value",
                        "IS_PINNED": "is_pinned",
                        "OLD_DATES": "old_dates",
                        "OLD_APPROVAL_STATUS": "old_approval_status",
                        "OLD_NUMBER_VALUE": "old_number_value",
                        "NEW_MULTI_ENUM_VALUES": "new_multi_enum_values"
                    },
                },
                'openapi_types': {
                    'task_gid':
                        (str,),
                    'update_story_request':
                        (UpdateStoryRequest,),
                    'opt_pretty':
                        (bool,),
                    'opt_fields':
                        ([str],),
                },
                'attribute_map': {
                    'task_gid': 'task_gid',
                    'opt_pretty': 'opt_pretty',
                    'opt_fields': 'opt_fields',
                },
                'location_map': {
                    'task_gid': 'path',
                    'update_story_request': 'body',
                    'opt_pretty': 'query',
                    'opt_fields': 'query',
                },
                'collection_format_map': {
                    'opt_fields': 'csv',
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.delete_story_endpoint = _Endpoint(
            settings={
                'response_type': (DeleteAttachment200Response,),
                'auth': [
                    'personalAccessToken'
                ],
                'endpoint_path': '/stories/{story_gid}',
                'operation_id': 'delete_story',
                'http_method': 'DELETE',
                'servers': None,
            },
            params_map={
                'all': [
                    'story_gid',
                    'opt_pretty',
                ],
                'required': [
                    'story_gid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'story_gid':
                        (str,),
                    'opt_pretty':
                        (bool,),
                },
                'attribute_map': {
                    'story_gid': 'story_gid',
                    'opt_pretty': 'opt_pretty',
                },
                'location_map': {
                    'story_gid': 'path',
                    'opt_pretty': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_stories_for_task_endpoint = _Endpoint(
            settings={
                'response_type': (GetStoriesForTask200Response,),
                'auth': [
                    'personalAccessToken'
                ],
                'endpoint_path': '/tasks/{task_gid}/stories',
                'operation_id': 'get_stories_for_task',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'task_gid',
                    'opt_pretty',
                    'limit',
                    'offset',
                    'opt_fields',
                ],
                'required': [
                    'task_gid',
                ],
                'nullable': [
                ],
                'enum': [
                    'opt_fields',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('opt_fields',): {

                        "CREATED_AT": "created_at",
                        "NEW_ENUM_VALUE": "new_enum_value",
                        "CREATED_BY": "created_by",
                        "NEW_NUMBER_VALUE": "new_number_value",
                        "IS_EDITED": "is_edited",
                        "PREVIEWS": "previews",
                        "OLD_MULTI_ENUM_VALUES": "old_multi_enum_values",
                        "NEW_NAME": "new_name",
                        "NEW_PEOPLE_VALUE": "new_people_value",
                        "PROJECT": "project",
                        "FOLLOWER": "follower",
                        "NEW_RESOURCE_SUBTYPE": "new_resource_subtype",
                        "TAG": "tag",
                        "OLD_RESOURCE_SUBTYPE": "old_resource_subtype",
                        "TASK": "task",
                        "IS_EDITABLE": "is_editable",
                        "STICKER_NAME": "sticker_name",
                        "STORY": "story",
                        "NEW_SECTION": "new_section",
                        "NUM_LIKES": "num_likes",
                        "NUM_HEARTS": "num_hearts",
                        "OLD_NAME": "old_name",
                        "RESOURCE_SUBTYPE": "resource_subtype",
                        "HTML_TEXT": "html_text",
                        "DUPLICATE_OF": "duplicate_of",
                        "HEARTS": "hearts",
                        "SOURCE": "source",
                        "TARGET": "target",
                        "LIKES": "likes",
                        "LIKED": "liked",
                        "OLD_DATE_VALUE": "old_date_value",
                        "OLD_ENUM_VALUE": "old_enum_value",
                        "HEARTED": "hearted",
                        "OLD_SECTION": "old_section",
                        "NEW_DATE_VALUE": "new_date_value",
                        "TYPE": "type",
                        "NEW_APPROVAL_STATUS": "new_approval_status",
                        "TEXT": "text",
                        "OLD_PEOPLE_VALUE": "old_people_value",
                        "ASSIGNEE": "assignee",
                        "NEW_DATES": "new_dates",
                        "NEW_TEXT_VALUE": "new_text_value",
                        "DUPLICATED_FROM": "duplicated_from",
                        "CUSTOM_FIELD": "custom_field",
                        "DEPENDENCY": "dependency",
                        "OLD_TEXT_VALUE": "old_text_value",
                        "IS_PINNED": "is_pinned",
                        "OLD_DATES": "old_dates",
                        "OLD_APPROVAL_STATUS": "old_approval_status",
                        "OLD_NUMBER_VALUE": "old_number_value",
                        "NEW_MULTI_ENUM_VALUES": "new_multi_enum_values"
                    },
                },
                'openapi_types': {
                    'task_gid':
                        (str,),
                    'opt_pretty':
                        (bool,),
                    'limit':
                        (int,),
                    'offset':
                        (str,),
                    'opt_fields':
                        ([str],),
                },
                'attribute_map': {
                    'task_gid': 'task_gid',
                    'opt_pretty': 'opt_pretty',
                    'limit': 'limit',
                    'offset': 'offset',
                    'opt_fields': 'opt_fields',
                },
                'location_map': {
                    'task_gid': 'path',
                    'opt_pretty': 'query',
                    'limit': 'query',
                    'offset': 'query',
                    'opt_fields': 'query',
                },
                'collection_format_map': {
                    'opt_fields': 'csv',
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_story_endpoint = _Endpoint(
            settings={
                'response_type': (GetStory200Response,),
                'auth': [
                    'personalAccessToken'
                ],
                'endpoint_path': '/stories/{story_gid}',
                'operation_id': 'get_story',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'story_gid',
                    'opt_pretty',
                    'limit',
                    'offset',
                    'opt_fields',
                ],
                'required': [
                    'story_gid',
                ],
                'nullable': [
                ],
                'enum': [
                    'opt_fields',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('opt_fields',): {

                        "CREATED_AT": "created_at",
                        "NEW_ENUM_VALUE": "new_enum_value",
                        "CREATED_BY": "created_by",
                        "NEW_NUMBER_VALUE": "new_number_value",
                        "IS_EDITED": "is_edited",
                        "PREVIEWS": "previews",
                        "OLD_MULTI_ENUM_VALUES": "old_multi_enum_values",
                        "NEW_NAME": "new_name",
                        "NEW_PEOPLE_VALUE": "new_people_value",
                        "PROJECT": "project",
                        "FOLLOWER": "follower",
                        "NEW_RESOURCE_SUBTYPE": "new_resource_subtype",
                        "TAG": "tag",
                        "OLD_RESOURCE_SUBTYPE": "old_resource_subtype",
                        "TASK": "task",
                        "IS_EDITABLE": "is_editable",
                        "STICKER_NAME": "sticker_name",
                        "STORY": "story",
                        "NEW_SECTION": "new_section",
                        "NUM_LIKES": "num_likes",
                        "NUM_HEARTS": "num_hearts",
                        "OLD_NAME": "old_name",
                        "RESOURCE_SUBTYPE": "resource_subtype",
                        "HTML_TEXT": "html_text",
                        "DUPLICATE_OF": "duplicate_of",
                        "HEARTS": "hearts",
                        "SOURCE": "source",
                        "TARGET": "target",
                        "LIKES": "likes",
                        "LIKED": "liked",
                        "OLD_DATE_VALUE": "old_date_value",
                        "OLD_ENUM_VALUE": "old_enum_value",
                        "HEARTED": "hearted",
                        "OLD_SECTION": "old_section",
                        "NEW_DATE_VALUE": "new_date_value",
                        "TYPE": "type",
                        "NEW_APPROVAL_STATUS": "new_approval_status",
                        "TEXT": "text",
                        "OLD_PEOPLE_VALUE": "old_people_value",
                        "ASSIGNEE": "assignee",
                        "NEW_DATES": "new_dates",
                        "NEW_TEXT_VALUE": "new_text_value",
                        "DUPLICATED_FROM": "duplicated_from",
                        "CUSTOM_FIELD": "custom_field",
                        "DEPENDENCY": "dependency",
                        "OLD_TEXT_VALUE": "old_text_value",
                        "IS_PINNED": "is_pinned",
                        "OLD_DATES": "old_dates",
                        "OLD_APPROVAL_STATUS": "old_approval_status",
                        "OLD_NUMBER_VALUE": "old_number_value",
                        "NEW_MULTI_ENUM_VALUES": "new_multi_enum_values"
                    },
                },
                'openapi_types': {
                    'story_gid':
                        (str,),
                    'opt_pretty':
                        (bool,),
                    'limit':
                        (int,),
                    'offset':
                        (str,),
                    'opt_fields':
                        ([str],),
                },
                'attribute_map': {
                    'story_gid': 'story_gid',
                    'opt_pretty': 'opt_pretty',
                    'limit': 'limit',
                    'offset': 'offset',
                    'opt_fields': 'opt_fields',
                },
                'location_map': {
                    'story_gid': 'path',
                    'opt_pretty': 'query',
                    'limit': 'query',
                    'offset': 'query',
                    'opt_fields': 'query',
                },
                'collection_format_map': {
                    'opt_fields': 'csv',
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.update_story_endpoint = _Endpoint(
            settings={
                'response_type': (GetStory200Response,),
                'auth': [
                    'personalAccessToken'
                ],
                'endpoint_path': '/stories/{story_gid}',
                'operation_id': 'update_story',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'story_gid',
                    'update_story_request',
                    'opt_pretty',
                    'opt_fields',
                ],
                'required': [
                    'story_gid',
                    'update_story_request',
                ],
                'nullable': [
                ],
                'enum': [
                    'opt_fields',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('opt_fields',): {

                        "CREATED_AT": "created_at",
                        "NEW_ENUM_VALUE": "new_enum_value",
                        "CREATED_BY": "created_by",
                        "NEW_NUMBER_VALUE": "new_number_value",
                        "IS_EDITED": "is_edited",
                        "PREVIEWS": "previews",
                        "OLD_MULTI_ENUM_VALUES": "old_multi_enum_values",
                        "NEW_NAME": "new_name",
                        "NEW_PEOPLE_VALUE": "new_people_value",
                        "PROJECT": "project",
                        "FOLLOWER": "follower",
                        "NEW_RESOURCE_SUBTYPE": "new_resource_subtype",
                        "TAG": "tag",
                        "OLD_RESOURCE_SUBTYPE": "old_resource_subtype",
                        "TASK": "task",
                        "IS_EDITABLE": "is_editable",
                        "STICKER_NAME": "sticker_name",
                        "STORY": "story",
                        "NEW_SECTION": "new_section",
                        "NUM_LIKES": "num_likes",
                        "NUM_HEARTS": "num_hearts",
                        "OLD_NAME": "old_name",
                        "RESOURCE_SUBTYPE": "resource_subtype",
                        "HTML_TEXT": "html_text",
                        "DUPLICATE_OF": "duplicate_of",
                        "HEARTS": "hearts",
                        "SOURCE": "source",
                        "TARGET": "target",
                        "LIKES": "likes",
                        "LIKED": "liked",
                        "OLD_DATE_VALUE": "old_date_value",
                        "OLD_ENUM_VALUE": "old_enum_value",
                        "HEARTED": "hearted",
                        "OLD_SECTION": "old_section",
                        "NEW_DATE_VALUE": "new_date_value",
                        "TYPE": "type",
                        "NEW_APPROVAL_STATUS": "new_approval_status",
                        "TEXT": "text",
                        "OLD_PEOPLE_VALUE": "old_people_value",
                        "ASSIGNEE": "assignee",
                        "NEW_DATES": "new_dates",
                        "NEW_TEXT_VALUE": "new_text_value",
                        "DUPLICATED_FROM": "duplicated_from",
                        "CUSTOM_FIELD": "custom_field",
                        "DEPENDENCY": "dependency",
                        "OLD_TEXT_VALUE": "old_text_value",
                        "IS_PINNED": "is_pinned",
                        "OLD_DATES": "old_dates",
                        "OLD_APPROVAL_STATUS": "old_approval_status",
                        "OLD_NUMBER_VALUE": "old_number_value",
                        "NEW_MULTI_ENUM_VALUES": "new_multi_enum_values"
                    },
                },
                'openapi_types': {
                    'story_gid':
                        (str,),
                    'update_story_request':
                        (UpdateStoryRequest,),
                    'opt_pretty':
                        (bool,),
                    'opt_fields':
                        ([str],),
                },
                'attribute_map': {
                    'story_gid': 'story_gid',
                    'opt_pretty': 'opt_pretty',
                    'opt_fields': 'opt_fields',
                },
                'location_map': {
                    'story_gid': 'path',
                    'update_story_request': 'body',
                    'opt_pretty': 'query',
                    'opt_fields': 'query',
                },
                'collection_format_map': {
                    'opt_fields': 'csv',
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )

    def create_story_for_task(
        self,
        task_gid,
        update_story_request,
        **kwargs
    ):
        """Create a story on a task  # noqa: E501

        Adds a story to a task. This endpoint currently only allows for comment stories to be created. The comment will be authored by the currently authenticated user, and timestamped when the server receives the request.  Returns the full record for the new story added to the task.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_story_for_task(task_gid, update_story_request, async_req=True)
        >>> result = thread.get()

        Args:
            task_gid (str): The task to operate on.
            update_story_request (UpdateStoryRequest): The story to create.

        Keyword Args:
            opt_pretty (bool): Provides “pretty” output. Provides the response in a “pretty” format. In the case of JSON this means doing proper line breaking and indentation to make it readable. This will take extra time and increase the response size so it is advisable only to use this during debugging.. [optional]
            opt_fields ([str]): This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include.. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            GetStory200Response
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['task_gid'] = \
            task_gid
        kwargs['update_story_request'] = \
            update_story_request
        return self.create_story_for_task_endpoint.call_with_http_info(**kwargs)

    def delete_story(
        self,
        story_gid,
        **kwargs
    ):
        """Delete a story  # noqa: E501

        Deletes a story. A user can only delete stories they have created.  Returns an empty data record.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_story(story_gid, async_req=True)
        >>> result = thread.get()

        Args:
            story_gid (str): Globally unique identifier for the story.

        Keyword Args:
            opt_pretty (bool): Provides “pretty” output. Provides the response in a “pretty” format. In the case of JSON this means doing proper line breaking and indentation to make it readable. This will take extra time and increase the response size so it is advisable only to use this during debugging.. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            DeleteAttachment200Response
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['story_gid'] = \
            story_gid
        return self.delete_story_endpoint.call_with_http_info(**kwargs)

    def get_stories_for_task(
        self,
        task_gid,
        **kwargs
    ):
        """Get stories from a task  # noqa: E501

        Returns the compact records for all stories on the task.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_stories_for_task(task_gid, async_req=True)
        >>> result = thread.get()

        Args:
            task_gid (str): The task to operate on.

        Keyword Args:
            opt_pretty (bool): Provides “pretty” output. Provides the response in a “pretty” format. In the case of JSON this means doing proper line breaking and indentation to make it readable. This will take extra time and increase the response size so it is advisable only to use this during debugging.. [optional]
            limit (int): Results per page. The number of objects to return per page. The value must be between 1 and 100.. [optional]
            offset (str): Offset token. An offset to the next page returned by the API. A pagination request will return an offset token, which can be used as an input parameter to the next request. If an offset is not passed in, the API will return the first page of results. 'Note: You can only pass in an offset that was returned to you via a previously paginated request.'. [optional]
            opt_fields ([str]): This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include.. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            GetStoriesForTask200Response
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['task_gid'] = \
            task_gid
        return self.get_stories_for_task_endpoint.call_with_http_info(**kwargs)

    def get_story(
        self,
        story_gid,
        **kwargs
    ):
        """Get a story  # noqa: E501

        Returns the full record for a single story.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_story(story_gid, async_req=True)
        >>> result = thread.get()

        Args:
            story_gid (str): Globally unique identifier for the story.

        Keyword Args:
            opt_pretty (bool): Provides “pretty” output. Provides the response in a “pretty” format. In the case of JSON this means doing proper line breaking and indentation to make it readable. This will take extra time and increase the response size so it is advisable only to use this during debugging.. [optional]
            limit (int): Results per page. The number of objects to return per page. The value must be between 1 and 100.. [optional]
            offset (str): Offset token. An offset to the next page returned by the API. A pagination request will return an offset token, which can be used as an input parameter to the next request. If an offset is not passed in, the API will return the first page of results. 'Note: You can only pass in an offset that was returned to you via a previously paginated request.'. [optional]
            opt_fields ([str]): This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include.. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            GetStory200Response
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['story_gid'] = \
            story_gid
        return self.get_story_endpoint.call_with_http_info(**kwargs)

    def update_story(
        self,
        story_gid,
        update_story_request,
        **kwargs
    ):
        """Update a story  # noqa: E501

        Updates the story and returns the full record for the updated story. Only comment stories can have their text updated, and only comment stories and attachment stories can be pinned. Only one of `text` and `html_text` can be specified.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_story(story_gid, update_story_request, async_req=True)
        >>> result = thread.get()

        Args:
            story_gid (str): Globally unique identifier for the story.
            update_story_request (UpdateStoryRequest): The comment story to update.

        Keyword Args:
            opt_pretty (bool): Provides “pretty” output. Provides the response in a “pretty” format. In the case of JSON this means doing proper line breaking and indentation to make it readable. This will take extra time and increase the response size so it is advisable only to use this during debugging.. [optional]
            opt_fields ([str]): This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include.. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            GetStory200Response
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['story_gid'] = \
            story_gid
        kwargs['update_story_request'] = \
            update_story_request
        return self.update_story_endpoint.call_with_http_info(**kwargs)

