"""
    Asana

    This is the interface for interacting with the [Asana Platform](https://developers.asana.com). Our API reference is generated from our [OpenAPI spec] (https://raw.githubusercontent.com/Asana/openapi/master/defs/asana_oas.yaml).  # noqa: E501

    The version of the OpenAPI document: 1.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from asana_preview.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from asana_preview.exceptions import ApiAttributeError


def lazy_import():
    from asana_preview.model.enum_option import EnumOption
    globals()['EnumOption'] = EnumOption


class CustomFieldBaseAllOf(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('format',): {
            'CURRENCY': "currency",
            'IDENTIFIER': "identifier",
            'PERCENTAGE': "percentage",
            'CUSTOM': "custom",
            'NONE': "none",
        },
        ('custom_label_position',): {
            'PREFIX': "prefix",
            'SUFFIX': "suffix",
        },
        ('asana_created_field',): {
            'None': None,
            'A_V_REQUIREMENTS': "a_v_requirements",
            'ACCOUNT_NAME': "account_name",
            'ACTIONABLE': "actionable",
            'ALIGN_SHIPPING_LINK': "align_shipping_link",
            'ALIGN_STATUS': "align_status",
            'ALLOTTED_TIME': "allotted_time",
            'APPOINTMENT': "appointment",
            'APPROVAL_STAGE': "approval_stage",
            'APPROVED': "approved",
            'ARTICLE_SERIES': "article_series",
            'BOARD_COMMITTEE': "board_committee",
            'BROWSER': "browser",
            'CAMPAIGN_AUDIENCE': "campaign_audience",
            'CAMPAIGN_PROJECT_STATUS': "campaign_project_status",
            'CAMPAIGN_REGIONS': "campaign_regions",
            'CHANNEL_PRIMARY': "channel_primary",
            'CLIENT_TOPIC_TYPE': "client_topic_type",
            'COMPLETE_BY': "complete_by",
            'CONTACT': "contact",
            'CONTACT_EMAIL_ADDRESS': "contact_email_address",
            'CONTENT_CHANNELS': "content_channels",
            'CONTENT_CHANNELS_NEEDED': "content_channels_needed",
            'CONTENT_STAGE': "content_stage",
            'CONTENT_TYPE': "content_type",
            'CONTRACT': "contract",
            'CONTRACT_STATUS': "contract_status",
            'COST': "cost",
            'CREATION_STAGE': "creation_stage",
            'CREATIVE_CHANNEL': "creative_channel",
            'CREATIVE_NEEDED': "creative_needed",
            'CREATIVE_NEEDS': "creative_needs",
            'DATA_SENSITIVITY': "data_sensitivity",
            'DEAL_SIZE': "deal_size",
            'DELIVERY_APPT': "delivery_appt",
            'DELIVERY_APPT_DATE': "delivery_appt_date",
            'DEPARTMENT': "department",
            'DEPARTMENT_RESPONSIBLE': "department_responsible",
            'DESIGN_REQUEST_NEEDED': "design_request_needed",
            'DESIGN_REQUEST_TYPE': "design_request_type",
            'DISCUSSION_CATEGORY': "discussion_category",
            'DO_THIS_TASK': "do_this_task",
            'EDITORIAL_CONTENT_STATUS': "editorial_content_status",
            'EDITORIAL_CONTENT_TAG': "editorial_content_tag",
            'EDITORIAL_CONTENT_TYPE': "editorial_content_type",
            'EFFORT': "effort",
            'EFFORT_LEVEL': "effort_level",
            'EST_COMPLETION_DATE': "est_completion_date",
            'ESTIMATED_TIME': "estimated_time",
            'ESTIMATED_VALUE': "estimated_value",
            'EXPECTED_COST': "expected_cost",
            'EXTERNAL_STEPS_NEEDED': "external_steps_needed",
            'FAVORITE_IDEA': "favorite_idea",
            'FEEDBACK_TYPE': "feedback_type",
            'FINANCIAL': "financial",
            'FUNDING_AMOUNT': "funding_amount",
            'GRANT_APPLICATION_PROCESS': "grant_application_process",
            'HIRING_CANDIDATE_STATUS': "hiring_candidate_status",
            'IDEA_STATUS': "idea_status",
            'IDS_LINK': "ids_link",
            'IDS_PATIENT_LINK': "ids_patient_link",
            'IMPLEMENTATION_STAGE': "implementation_stage",
            'INSURANCE': "insurance",
            'INTERVIEW_AREA': "interview_area",
            'INTERVIEW_QUESTION_SCORE': "interview_question_score",
            'ITERO_SCAN_LINK': "itero_scan_link",
            'JOB_S_APPLIED_TO': "job_s_applied_to",
            'LAB': "lab",
            'LAUNCH_STATUS': "launch_status",
            'LEAD_STATUS': "lead_status",
            'LOCALIZATION_LANGUAGE': "localization_language",
            'LOCALIZATION_MARKET_TEAM': "localization_market_team",
            'LOCALIZATION_STATUS': "localization_status",
            'MEETING_MINUTES': "meeting_minutes",
            'MEETING_NEEDED': "meeting_needed",
            'MINUTES': "minutes",
            'MRR': "mrr",
            'MUST_LOCALIZE': "must_localize",
            'NAME_OF_FOUNDATION': "name_of_foundation",
            'NEED_TO_FOLLOW_UP': "need_to_follow_up",
            'NEXT_APPOINTMENT': "next_appointment",
            'NEXT_STEPS_SALES': "next_steps_sales",
            'NUM_PEOPLE': "num_people",
            'NUMBER_OF_USER_REPORTS': "number_of_user_reports",
            'OFFICE_LOCATION': "office_location",
            'ONBOARDING_ACTIVITY': "onboarding_activity",
            'OWNER': "owner",
            'PARTICIPANTS_NEEDED': "participants_needed",
            'PATIENT_DATE_OF_BIRTH': "patient_date_of_birth",
            'PATIENT_EMAIL': "patient_email",
            'PATIENT_PHONE': "patient_phone",
            'PATIENT_STATUS': "patient_status",
            'PHONE_NUMBER': "phone_number",
            'PLANNING_CATEGORY': "planning_category",
            'POINT_OF_CONTACT': "point_of_contact",
            'POSITION': "position",
            'POST_FORMAT': "post_format",
            'PRESCRIPTION': "prescription",
            'PRIORITY': "priority",
            'PRIORITY_LEVEL': "priority_level",
            'PRODUCT': "product",
            'PRODUCT_STAGE': "product_stage",
            'PROGRESS': "progress",
            'PROJECT_SIZE': "project_size",
            'PROJECT_STATUS': "project_status",
            'PROPOSED_BUDGET': "proposed_budget",
            'PUBLISH_STATUS': "publish_status",
            'REASON_FOR_SCAN': "reason_for_scan",
            'REFERRAL': "referral",
            'REQUEST_TYPE': "request_type",
            'RESEARCH_STATUS': "research_status",
            'RESPONSIBLE_DEPARTMENT': "responsible_department",
            'RESPONSIBLE_TEAM': "responsible_team",
            'RISK_ASSESSMENT_STATUS': "risk_assessment_status",
            'ROOM_NAME': "room_name",
            'SALES_COUNTERPART': "sales_counterpart",
            'SENTIMENT': "sentiment",
            'SHIPPING_LINK': "shipping_link",
            'SOCIAL_CHANNELS': "social_channels",
            'STAGE': "stage",
            'STATUS': "status",
            'STATUS_DESIGN': "status_design",
            'STATUS_OF_INITIATIVE': "status_of_initiative",
            'SYSTEM_SETUP': "system_setup",
            'TASK_PROGRESS': "task_progress",
            'TEAM': "team",
            'TEAM_MARKETING': "team_marketing",
            'TEAM_RESPONSIBLE': "team_responsible",
            'TIME_IT_TAKES_TO_COMPLETE_TASKS': "time_it_takes_to_complete_tasks",
            'TIMEFRAME': "timeframe",
            'TREATMENT_TYPE': "treatment_type",
            'TYPE_WORK_REQUESTS_IT': "type_work_requests_it",
            'USE_AGENCY': "use_agency",
            'USER_NAME': "user_name",
            'VENDOR_CATEGORY': "vendor_category",
            'VENDOR_TYPE': "vendor_type",
            'WORD_COUNT': "word_count",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'description': (str,),  # noqa: E501
            'enum_options': ([EnumOption],),  # noqa: E501
            'precision': (int,),  # noqa: E501
            'format': (str,),  # noqa: E501
            'currency_code': (str, none_type,),  # noqa: E501
            'custom_label': (str, none_type,),  # noqa: E501
            'custom_label_position': (str,),  # noqa: E501
            'is_global_to_workspace': (bool,),  # noqa: E501
            'has_notifications_enabled': (bool,),  # noqa: E501
            'asana_created_field': (str, none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'description': 'description',  # noqa: E501
        'enum_options': 'enum_options',  # noqa: E501
        'precision': 'precision',  # noqa: E501
        'format': 'format',  # noqa: E501
        'currency_code': 'currency_code',  # noqa: E501
        'custom_label': 'custom_label',  # noqa: E501
        'custom_label_position': 'custom_label_position',  # noqa: E501
        'is_global_to_workspace': 'is_global_to_workspace',  # noqa: E501
        'has_notifications_enabled': 'has_notifications_enabled',  # noqa: E501
        'asana_created_field': 'asana_created_field',  # noqa: E501
    }

    read_only_vars = {
        'is_global_to_workspace',  # noqa: E501
        'asana_created_field',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """CustomFieldBaseAllOf - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            description (str): [Opt In](/docs/inputoutput-options). The description of the custom field.. [optional]  # noqa: E501
            enum_options ([EnumOption]): *Conditional*. Only relevant for custom fields of type `enum`. This array specifies the possible values which an `enum` custom field can adopt. To modify the enum options, refer to [working with enum options](/reference/createenumoptionforcustomfield).. [optional]  # noqa: E501
            precision (int): Only relevant for custom fields of type ‘Number’. This field dictates the number of places after the decimal to round to, i.e. 0 is integer values, 1 rounds to the nearest tenth, and so on. Must be between 0 and 6, inclusive. For percentage format, this may be unintuitive, as a value of 0.25 has a precision of 0, while a value of 0.251 has a precision of 1. This is due to 0.25 being displayed as 25%. The identifier format will always have a precision of 0.. [optional]  # noqa: E501
            format (str): The format of this custom field.. [optional]  # noqa: E501
            currency_code (str, none_type): ISO 4217 currency code to format this custom field. This will be null if the `format` is not `currency`.. [optional]  # noqa: E501
            custom_label (str, none_type): This is the string that appears next to the custom field value. This will be null if the `format` is not `custom`.. [optional]  # noqa: E501
            custom_label_position (str): Only relevant for custom fields with `custom` format. This depicts where to place the custom label. This will be null if the `format` is not `custom`.. [optional]  # noqa: E501
            is_global_to_workspace (bool): This flag describes whether this custom field is available to every container in the workspace. Before project-specific custom fields, this field was always true.. [optional]  # noqa: E501
            has_notifications_enabled (bool): *Conditional*. This flag describes whether a follower of a task with this field should receive inbox notifications from changes to this field.. [optional]  # noqa: E501
            asana_created_field (str, none_type): *Conditional*. A unique identifier to associate this field with the template source of truth.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """CustomFieldBaseAllOf - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            description (str): [Opt In](/docs/inputoutput-options). The description of the custom field.. [optional]  # noqa: E501
            enum_options ([EnumOption]): *Conditional*. Only relevant for custom fields of type `enum`. This array specifies the possible values which an `enum` custom field can adopt. To modify the enum options, refer to [working with enum options](/reference/createenumoptionforcustomfield).. [optional]  # noqa: E501
            precision (int): Only relevant for custom fields of type ‘Number’. This field dictates the number of places after the decimal to round to, i.e. 0 is integer values, 1 rounds to the nearest tenth, and so on. Must be between 0 and 6, inclusive. For percentage format, this may be unintuitive, as a value of 0.25 has a precision of 0, while a value of 0.251 has a precision of 1. This is due to 0.25 being displayed as 25%. The identifier format will always have a precision of 0.. [optional]  # noqa: E501
            format (str): The format of this custom field.. [optional]  # noqa: E501
            currency_code (str, none_type): ISO 4217 currency code to format this custom field. This will be null if the `format` is not `currency`.. [optional]  # noqa: E501
            custom_label (str, none_type): This is the string that appears next to the custom field value. This will be null if the `format` is not `custom`.. [optional]  # noqa: E501
            custom_label_position (str): Only relevant for custom fields with `custom` format. This depicts where to place the custom label. This will be null if the `format` is not `custom`.. [optional]  # noqa: E501
            is_global_to_workspace (bool): This flag describes whether this custom field is available to every container in the workspace. Before project-specific custom fields, this field was always true.. [optional]  # noqa: E501
            has_notifications_enabled (bool): *Conditional*. This flag describes whether a follower of a task with this field should receive inbox notifications from changes to this field.. [optional]  # noqa: E501
            asana_created_field (str, none_type): *Conditional*. A unique identifier to associate this field with the template source of truth.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
